/*! 
* This Source Code Form is subject to the terms of the Mozilla Public
* License, v. 2.0. If a copy of the MPL was not distributed with this file,
* You can obtain one at http://mozilla.org/MPL/2.0/.
*
* Copyright(c) 2012 Apogee Imaging Systems, Inc. 
* \class AltaUsbIo 
* \brief class for managing the AltaU series IO 
* 
*/ 


#ifndef ALTAUSBIO_INCLUDE_H__ 
#define ALTAUSBIO_INCLUDE_H__ 

#include "CamUsbIo.h" 

class AltaUsbIo : public CamUsbIo
{ 
    public: 
        AltaUsbIo( const std::string & DeviceEnum );
        virtual ~AltaUsbIo(); 

         void Program(const std::string & FilenameCamCon,
            const std::string & FilenameBufCon, const std::string & FilenameFx2,
            const std::string & FilenameGpifCamCon,const std::string & FilenameGpifBufCon,
            const std::string & FilenameGpifFifo, bool Print2StdOut=false );

        void ReadHeader( Eeprom::Header & hdr );

        void SetSerialNumber(const std::string & num);
        std::string GetSerialNumber();

        private:
            void DownloadFirmware();

            void IncrEepromAddrBlockBank(uint16_t IncrSize,
                uint16_t & Addr, uint8_t & Bank, 
                uint8_t & Block);
            
            std::string m_fileName;
}; 

#endif